var skp_loaded = true;
var datum_table = {};
var ref_height = null;
var cb_queue = [];


function next_cb(){
	cbURL = cb_queue.pop();
	if(typeof(cbURL)=="string"){
		window.location=cbURL;
	}else{
		window.location="skp:queue_completed"
	}
}


function rbyCB(cb_name, arg){
	var cbURL = 'skp:'+cb_name;
	if(arg){
		argStr = arg;
		if(typeof(arg) != "string" && typeof(arg) != "number"){
			argStr = JSON.stringify(arg);
		}
		if(argStr.length < 2038){
			cbURL += '@'+argStr;
		}else{
			alert("maximum argument length exceeded for callback ["+cb_name+"], \nplease contact support.")
		}
	}
	if(skp_loaded){
		cb_queue.push(cbURL);
		window.location="skp:process_queue";
	}else{
		console.log(cb_name+' callback skipped, SketchUp not loaded.\ncbURL:'+cbURL);
	}
}

// from ruby to js functions

function set_skp_loaded(){
	skp_loaded = true;
}

function set_active_row_by_datum_table(){
	Object.keys(datum_table).some(function (this_id) { 
    	var datum_object = datum_table[this_id];
    	if(datum_object["active"]==true){
    		var a_datum_row = find_datum_row_by_id(this_id);
    		var a_ele = a_datum_row.find(".active-datum-container");
    		setNewActiveDatum(a_ele);
    		return true;
    	}
    });
}

function sort_rows_by_datum_table(){
	var keys = Object.keys(datum_table);
	var order = {};
	var prev_row=0;
	keys.forEach(function (id) { 
		var datum_object = datum_table[id];
		order[datum_object.list_position]=id;
	});
	Object.keys(order).sort().forEach(function (itm_pos) {
		if(prev_row){
			var this_row = find_datum_row_by_id(order[itm_pos]);
			prev_row.after(this_row);
			prev_row = this_row;
		}else{
			prev_row = find_datum_row_by_id(order[itm_pos]);
		}

	});
}

function receive_table(tableObj){
	// alert(tableObj);
	// datum_table = JSON.parse(tableString);
	deserializing = true;
	datum_table = tableObj;
	clearRows();
	dtableUpdated();
	deserializing = false;
	var a_datum_id = -1;
	set_active_row_by_datum_table()
	sort_rows_by_datum_table()
    // iteration code
}

// function add_datum(dat_label,dat_value,dat_id){
// 	var new_row = add_row();
// 	var id = new_row.find(".datum-id");
// 	var label = new_row.find(".datum-label");
// 	var datum = new_row.find(".datum-distance");
// 	id.val(dat_id);
// 	label.val(dat_label);
// 	datum.val(dat_value);
// 	refreshLabels();
// }

function set_ref_height(h){
	ref_height = h;
	ref_height_updated();
}

function set_unit_multiplier(mult){
	unit_multiplier = mult;
}

function set_unit_suffix(sfx){
	unit_suffix = sfx;
	unit_suffix_updated();
}

// from js to ruby functions

function send_active_datum_id(id){
	rbyCB("set_active_datum",id);
}

function send_datum_update(dat){
	// alert("calling send_datum_update with args:");
	// alert(JSON.stringify(dat));
	rbyCB("send_datum_update",dat)
}