
var deserializing = false
var unit_multiplier = 1.0
var unit_suffix = "in"
var fixed_len = 3

window.onerror = function() {
    alert(JSON.stringify(arguments));
}

var selected_row = null;
var active_row = null;

function updateSelection(item){
    if(selected_row){
        selected_row.removeClass("current-row");
    }
    selected_row = item;
    selected_row.addClass("current-row");
} 

function setNewActiveDatum(item){ 
    if(!deserializing){
        $(".active-datum-container div").removeClass("active_item");
        $(".active-datum-container div").addClass("inactive_item");
        item.find("div").removeClass("inactive_item");
        item.find("div").addClass("active_item");
        active_row = item.closest(".itm");
        send_active_datum_id(item.closest(".itm").find(".datum-id").val());
    }

}   

function getActiveDatumItem(){
    return $("#original_items .itm").filter(function(idx){return $(this).find(".active-datum-container div").hasClass("active_item")})
}

function enableListeners(){
    //make inputs editable after double clicking them
    $(".val-container").unbind('dblclick');
    $(".val-container").dblclick(function () {
        //old way
        // $(this).children(":input").prop( "disabled", false );
        $(this).find("label").prop( "hidden", true );
        $(this).find(":input").prop( "hidden", false );
        $(this).find(":input").prop( "disabled", false );
        $(this).find(":input").focus().select();

    });
    $(".active-datum-container").unbind('click');
    $(".active-datum-container").click(function () {
        setNewActiveDatum($(this));
        //old way
        // $(this).children(":input").prop( "disabled", false );
    });
    $(".datum-distance").on('input', function() {
        var txt=$(this).val();
        var invalid=true;
        if(txt.length == 1 && txt == "-"){
            invalid=false;
        }else if($.isNumeric(txt)){
            invalid=false;
        }
        if(invalid){
            txt = txt.slice(0, -1);
        }
        $(this).val(txt.trim());
    });

}

function clearRows(){
    $("#original_items").empty();
}

function refreshLabels(){

    commitDatumUpdate($("input:visible"));
    $(".val-container").each(function(){
        $(this).find(":input").prop("disabled", true);
        $(this).find(":input").prop("hidden", true);
        $(this).find("label").text($(this).find(":input").val());
        $(this).find("label").prop("hidden", false);
    });
}
function addslashes( str ) {
    return (str + '').replace(/[\\"']/g, '\\$&').replace(/\u0000/g, '\\0');
}

function compileDatumUpdateById(id){
    var row = find_datum_row_by_id(id);
    var label = row.find(".datum-label");
    var distance = row.find(".datum-distance");
    var update = {
        "id":id,
        "name": btoa(label.val()),
        "height": btoa(distance.val()),
        "list_position":row.index()
    
    }
    return update;

}

function commitDatumUpdate(tar){
    if(tar.length == 0 ){return}
    var id = get_datum_id_for_element(tar.first());
    var update = compileDatumUpdateById(id);
    // alert("id: "+id+"\nupdate: "+JSON.stringify(update));
    send_datum_update(update);
}



function add_row(){
    var template = jQuery("#item-template li").clone();
    template.click(function(){updateSelection(template)});
    jQuery("#original_items").append(template);
    enableListeners();
    return template;
}

function add_datum(dat_label,dat_value,dat_id){
    var new_row = add_row();
    new_row.find(".datum-id").val(dat_id);
    populate_datum_by_id(dat_id,dat_label,dat_value);
    // alert($("#original_items").children().length );
    if($("#original_items").children().length == 1){
        // alert("congrats on your first entry!");
        setNewActiveDatum(new_row.find(".active-datum-container"));
    }
}

function get_datum_id_for_element(ele){
    itm = ele.closest('.itm');
    return itm.find(".datum-id").val();
}

function find_datum_row_by_id(id){
    var row = $('.datum-id').filter(function(){return $(this).val() == id}).closest(".itm")
    // alert("find_datum_row_by_id("+id+"): "+row.length);
    return row;
}   

function populate_datum_by_id(dat_id,dat_label,dat_value){
    var row = find_datum_row_by_id(dat_id); 
    if(row.length > 0){ 
        // alert("row: "+row);
        var label = row.find(".datum-label");
        var distance = row.find(".datum-distance");
        label.val(dat_label);
        // distance.val(rnd_flt(dat_value*unit_multiplier));
        distance.val(dat_value);
        refreshLabels();
    }else{
        // alert("should be adding a new datum row");
        add_datum(dat_label,dat_value,dat_id);
    }
}
function dtableUpdated(){
    $.each(datum_table, function(i,datum_obj){
        // datum_obj = datum_table[i];
        //alert("i("+typeof(i)+"): "+i+"\nname("+typeof(datum_obj.name)+"): "+datum_obj.name+"\nheight("+typeof(datum_obj.height)+"): "+datum_obj.height);
        // alert("processing: "+datum_obj.name);
        populate_datum_by_id(i,datum_obj.name,datum_obj.height);
    });
}

var flt_rnd_cnt = 0;

function rnd_flt(flt){
    m = 1/Math.pow(10, fixed_len);
    r = Math.floor(flt/m+0.50001)*m;
    delta = Math.abs(flt - r);
    if((delta >= 1) && (flt_rnd_cnt < 100)){
        flt_rnd_cnt = flt_rnd_cnt + 1;
        r = rnd_flt(flt);
        flt_rnd_cnt = 0;
    }
    return r;
}

function ref_height_updated(){
    // $('#output').html(rnd_flt(ref_height*unit_multiplier));
    $('#output').html(ref_height);
}

function unit_suffix_updated(){
    // $('#output_units').html(unit_suffix);
}

function update_datum_list_position(itm){
    var id = get_datum_id_for_element(itm);
    var update = compileDatumUpdateById(id);
    // alert("id: "+id+"\nupdate: "+JSON.stringify(update));
    send_datum_update(update);

}

function sort_rows_by_datum_list_position(){

}

function row_order_changed(){
    console.log("order of items has changed!");
    $("#original_items").children().each(function(){
        update_datum_list_position($(this));
    });
}

jQuery(function(){   

    $("#original_items" ).sortable({
        containment: 'window',
        scroll: false,
        placeholder: "dummyItem",
        handle: ".grip-container",
        update: function( event, ui ) {row_order_changed();}
    });
    // $("#original_items" ).disableSelection();

    // //enable our tool if the window gets focus

    // $(window).click(function() {
    //     a_dat = getActiveDatumItem();
    //     if(a_dat.length > 0){
    //         rbyCB("activate_tool")
    //     }
    // });


    //make inputs non editable after clicking outside of the input box
    $(document).click(function(e) {
        var target = e.target;
        var lockdown = true;
        if(target.type == "text"){
            if(!target.hasAttribute("disabled")){
                lockdown=false
            }
        }
        if(lockdown){
            //old way
            // $(".val-container").children(":input").prop("disabled", true);
            refreshLabels();
        }
    });
    $(document).keypress(function (e) {
        if (e.which == 13) {
            refreshLabels();
        }
    });

    $("#addButton").click(function () {
        rbyCB("add_new_datum",null);
    });

    $("#trashButton").click(function () {
        var itm = $("#original_items .current-row");
        if(itm.length > 0){
            var id = get_datum_id_for_element(itm);

            if(getActiveDatumItem()[0] == selected_row[0]){
                if($("#original_items").children().length > 1){
                    var new_active_datum = itm.prev();
                    if(new_active_datum.length == 0){
                        new_active_datum = itm.next();
                    }
                    setNewActiveDatum(new_active_datum);
                }else{
                    send_active_datum_id("-99999");
                }
            }
            itm.remove();
            rbyCB("remove_datum",id);
        }

        
    });

    $(".itm").click(function() {

        // console.log("selected a row, good job!");
        console.log($(this));
        updateSelection($(this));
    })
    $(".itm").on("contextmenu", function(e) {
        e.preventDefault();
        console.log("nice right click, good job!");
    });
    $(document).on("contextmenu", function(e) {
        e.preventDefault();
    });


});
